#include "config.h"
#include <pthread.h>
#include <gtk/gtk.h>
#include <unistd.h>

#ifdef USE_DEBUG
#define debug(x) printf(x);printf("\n");fflush(stdout); */
#else
#define debug(x)

#endif

pthread_cond_t Xcond = PTHREAD_COND_INITIALIZER;
pthread_mutex_t Xmutex = PTHREAD_MUTEX_INITIALIZER;
int Xpipe[2];

/*this routine is called when something has written to the Xpipe*/

#ifndef USE_DEBUG
static void threadcall(void *a,int b,GdkInputCondition c) {

	debug("call");

	pthread_cond_wait(&Xcond,&Xmutex);
	debug("call 2");

}
#endif

void gtk_threads_init(void) {
#ifndef USE_DEBUG
	pipe(Xpipe);
	pthread_mutex_lock(&Xmutex);

#endif
}

void gtk_threads_main() {
#ifndef USE_DEBUG
	gdk_input_add(Xpipe[0],GDK_INPUT_READ,threadcall,0);
#endif
	gtk_main();
}


     /*
     gtk_calls not made by the main thread should be wrapped between
     gtk_thread_enter and gtk_thread_leave
     */
void gtk_threads_enter(){
#ifndef USE_DEBUG
	char c;
	debug("enter");

	write(Xpipe[1],"A",1);
	debug("enter 2");

	pthread_mutex_lock(&Xmutex);
	debug("enter 3");

	read(Xpipe[0],&c,1);

	debug("enter 4");

#endif
}

void gtk_threads_leave(){
#ifndef USE_DEBUG
	debug("leave");
	pthread_cond_signal(&Xcond);
	debug("leave 2");
	pthread_mutex_unlock(&Xmutex);
	debug("leave 3");
#endif

}

void gtk_thread_exit(){
#ifndef USE_DEBUG
	pthread_cond_destroy(&Xcond);
	pthread_mutex_destroy(&Xmutex);
	close(Xpipe[0]);
	close(Xpipe[1]);
#endif
}
